"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.filterFile = exports.parsehtml = exports.copyFilesRecursive = exports.injectString = void 0;
const path = __importStar(require("path"));
const fs_1 = require("fs");
function injectString(source, index, injected) {
    return [
        source.substring(0, index),
        injected,
        source.substring(index)
    ].join('\n');
}
exports.injectString = injectString;
function copyFilesRecursive(src, dst, filter = (() => true)) {
    return __awaiter(this, void 0, void 0, function* () {
        const files = yield getFiles(src);
        yield Promise.all(files
            .filter(filter)
            .map((file) => __awaiter(this, void 0, void 0, function* () {
            const src_ = path.relative(src, file);
            const dst_ = path.join(dst, src_);
            yield fs_1.promises.mkdir(path.dirname(dst_), { recursive: true });
            yield fs_1.promises.copyFile(file, dst_);
        })));
    });
}
exports.copyFilesRecursive = copyFilesRecursive;
function getFiles(src = "./") {
    return __awaiter(this, void 0, void 0, function* () {
        const entries = yield fs_1.promises.readdir(src, { withFileTypes: true });
        const files = entries
            .filter(file => !file.isDirectory())
            .map(file => path.join(src, file.name));
        const folders = entries.filter(folder => folder.isDirectory());
        yield Promise.all(folders.map((folder) => __awaiter(this, void 0, void 0, function* () {
            const innerSrc = path.join(src, folder.name);
            const innerFiles = yield getFiles(innerSrc);
            files.push(...innerFiles);
        })));
        return files;
    });
}
function parsehtml(src) {
    var _a, _b, _c, _d;
    let start, end;
    start = (_a = src.match(/<head>/)) === null || _a === void 0 ? void 0 : _a.index;
    if (!start)
        throw new Error("<head> not found");
    end = (_b = src.match(/<\/head>/)) === null || _b === void 0 ? void 0 : _b.index;
    if (!end)
        throw new Error("</head> not found");
    const head = src.slice(start + "<head>".length, end).trim();
    start = (_c = src.match(/<body>/)) === null || _c === void 0 ? void 0 : _c.index;
    if (!start)
        throw new Error("<body> not found");
    end = (_d = src.match(/<\/body>/)) === null || _d === void 0 ? void 0 : _d.index;
    if (!end)
        throw new Error("</body> not found");
    const body = src.slice(start + "<body>".length, end).trim();
    return { head, body };
}
exports.parsehtml = parsehtml;
function filterFile(file) {
    const name = path.basename(file);
    if (name.endsWith(".js.map"))
        return false;
    if (name.endsWith(".css.map"))
        return false;
    else if (name === "index.html")
        return false;
    else if (name.endsWith(".pdf"))
        return false;
    else
        return true;
}
exports.filterFile = filterFile;
